/**
 * Easy Coverage for Java
 * <p>
 * Copyright 2011-2012 Tocea Technology Solutions http://www.tocea.com
 * <p>
 * This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.
 * <p>
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 * <p>
 * You should have received a copy of the GNU Lesser General Public License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 * <p>
 **/

package com.tocea.easycoverage.framework.api;



import java.io.File;



/**
 * This type describes the blind test.
 * <p>
 * 
 * @author $Author: sleroy $
 * @since 1 févr. 2012
 * @copyright Copyright (C) 2010-2012 TOCEA
 */

public interface IBlindTest
{
    
    
    /**
     * This method performs the addition of a class.
     * 
     * @param _class
     *            the class to add.
     */
    void addClass(final Class<?> _class);
    
    
    /**
     * This method performs the addition of the object to test.
     * 
     * @param _object
     *            the object
     */
    void addObject(Object _object);
    
    
    /**
     * This method performs the removal of a class. To use for instance after a scanFolder to remove a class from the test.
     * 
     * @param _class
     *            the class to add.
     */
    void removeClass(final Class<?> _class);
    
    
    /**
     * This method performs the launching of every test
     * 
     * @return
     */
    boolean runTests();
    
    
    /**
     * This method performs the scan of a folder to find classes.
     * 
     * @param _file
     *            the folder
     */
    void scanFolder(final File _file);
    
}
